#ifndef COROUTINE_H
#define COROUTINE_H
#ifdef __cplusplus
extern "C" {
#endif

#define CO_STACK_SIZE 40*4

#ifndef __ASSEMBLY__
typedef void * coroutine_t;

coroutine_t co_create(void (*func)(void*), void *data);
void co_delete(coroutine_t co);
int co_call(coroutine_t co);
void *co_get_data(coroutine_t co);

void co_resume(void);
void co_goto(void (*func)(void*));

void co_exit(void);
void co_exit_thumb(void);
#endif // __ASSEMBLY__
#ifdef __cplusplus
}
#endif
#endif
